import gnu.io.*;
import java.io.*;

public class serialPort extends java.lang.Object
{  
    private static SerialPort port;
    private static InputStream input;
    private static OutputStream output;
    // open serial port at specified baud with other appropriate parameters.
    // returns:
    // 0 on success
    // -1 on failure to open serial port
    // -2 on failure to read port state
    // -3 on failure to set port state
    // coms are: 1 = "COM1"; 2 = "COM2" et cetera    
    // baud rates are: 1 = 9600; 2=19200; 3=38400; 4=57600; 5=115200; 6=230400
    public synchronized static int openSerial(int comNum, int baudSpec) {
        switch (baudSpec) {
            case 1:
                baudSpec = 9600;
                break;                
            case 2:
                baudSpec = 19200;
                break;
            case 3:
                baudSpec = 38400;
                break;
            case 4:
                baudSpec = 57600;
                break;
            case 5:
                baudSpec = 115200;
                break;
            case 6:
                baudSpec = 230400;
                break;
            default:
                return -1;
        }
        try {
        CommPortIdentifier cpi = CommPortIdentifier.getPortIdentifier("COM" + comNum);
        port = (SerialPort)cpi.open("Camera App", 1000);
        port.setSerialPortParams(baudSpec, SerialPort.DATABITS_8,
                                      SerialPort.STOPBITS_1,
                                      SerialPort.PARITY_NONE);
        port.setFlowControlMode(SerialPort.FLOWCONTROL_NONE);
        input = port.getInputStream();
        output = port.getOutputStream();
        } catch (Exception e) {
            e.printStackTrace();
            return -1;
        }
        return 0;
    }
    
    public synchronized static int closeSerial() {
        try {
            input.close();
            port.close();
        } catch (IOException IOe) {
        }
        return 0;
    }
        
    // returns 0 on success or -1 on failure to send byte
    public synchronized static int sendByte(int theByte) {
        try {
            output.write(theByte);
        } catch (IOException IOe) {
            return -1;
        }
        return 0;
    }
        
    // initialTimeout is measured in milliseconds //
    // returns -6 on failure to set timeout, 0 on success
    public synchronized static int setReadTimeout(int initialTimeout) {
        try {
            port.enableReceiveTimeout(initialTimeout);
        } catch (UnsupportedCommOperationException e) {
            return -6;
        }
        return 0;
    }
    // returns -1 in error or timeout, else returns int between 0 and 255
    public synchronized static int readByte() {
        try {
            int x = input.read();
            return x;
        } catch (IOException IOe) {
            return -1;
        }
    }
}
