#include <stdio.h>
#include <math.h>
#include "control.h"

#define ARR_LEN (ARM_MAX - ARM_MIN)

int main (int argc, char* args[])
{
    int x;
    FILE *f = fopen("lut.txt", "wb");
    if (f == NULL) {
        fprintf(stderr, "Failed to open output file lut.txt\n");
        return 1;
    }

    fprintf(f, "#define AUTO_WRIST_LUT_LEN %d;\n\n", ARR_LEN);
    fprintf(f, "static rom const unsigned char auto_wrist_lut[] = \n{");
    for (x = ARM_MIN; x < ARM_MAX; ++x)
    {
	double val;
	int output;

	if ((x - ARM_MIN) % 8 == 0)
	    fprintf(f, "\n  ");
	

	if (x < ARM_PICKUP)
	    val = WRIST_PICKUP;
	else if (x < ARM_SCORELO)
	    val = ((double)(WRIST_SCORELO - WRIST_PICKUP) / (ARM_SCORELO - ARM_PICKUP)) * (x - ARM_PICKUP) + WRIST_PICKUP;
	else if (x < ARM_SCOREMID)
	    val = ((double)(WRIST_SCOREMID - WRIST_SCORELO) / (ARM_SCOREMID - ARM_SCORELO)) * (x - ARM_SCORELO) + WRIST_SCORELO;
	else if (x < ARM_STRAIGHT)
	    val = ((double)(WRIST_ARMSTRAIGHT - WRIST_SCOREMID) / (ARM_STRAIGHT - ARM_SCOREMID)) * (x - ARM_SCOREMID) + WRIST_SCOREMID;
	else if (x < ARM_SCOREHI)
	    val = ((double)(WRIST_SCOREHI - WRIST_ARMSTRAIGHT) / (ARM_SCOREHI - ARM_STRAIGHT)) * (x - ARM_STRAIGHT) + WRIST_ARMSTRAIGHT;
	else
	    val = WRIST_MIN;

	if (val > WRIST_MAX)
	    val = WRIST_MAX;
	else if (val < WRIST_MIN)
	    val = WRIST_MIN;

	output = round(val) - WRIST_MIN;
	fprintf(f, "%d", output);
	if (x == ARM_MAX - 1)
	    fprintf(f, "\n");
	else
	    fprintf(f, ", ");
    }

    fprintf(f, "};\n");
    return 0;
}
