#include "about.h"
#include "logo.xpm"

enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

int idClose = wxNewId();

BEGIN_EVENT_TABLE(AboutFrame, wxFrame)
	EVT_BUTTON(idClose, AboutFrame::OnClose)
END_EVENT_TABLE()


AboutFrame::AboutFrame(wxFrame *frame, const wxString& title): wxFrame(frame, -1, title)
{
	static_bitmap_logo = new wxStaticBitmap(this, -1, wxBitmap(logo_xpm));
	label_about = new wxStaticText(this, -1, _T(""));
	button_close = new wxButton(this, idClose, _("Close"));

	set_properties();
	do_layout();
}

AboutFrame::~AboutFrame()
{
}

void AboutFrame::do_layout()
{
	wxBoxSizer* sizer_1 = new wxBoxSizer(wxVERTICAL);
	sizer_1->Add(static_bitmap_logo, 0, wxALL, 5);
	sizer_1->Add(label_about, 0, wxALL|wxEXPAND, 5);
	sizer_1->Add(button_close, 0, wxALL|wxALIGN_CENTER_HORIZONTAL, 5);
	SetAutoLayout(true);
	SetSizer(sizer_1);
	sizer_1->Fit(this);
	sizer_1->SetSizeHints(this);
	Layout();
}

void AboutFrame::set_properties()
{
	wxString about_string = _("Team 1511 Lookup Table Generator\n");
	about_string << _("http://www.penfieldrobotics.com\n\n");
	about_string << _("Version 1.0\n");
	about_string << _("wxWidgets version ") << wxbuildinfo(long_f) << _T("\n");
	about_string << _("Coded by Rajeev Sharma\n\n");
	about_string << _("Good luck teams!");
	label_about->SetLabel(about_string);

	SetTitle(_("About.."));
}

void AboutFrame::OnClose(wxCommandEvent& event)
{
	Close();
}
